#ifdef GL_ES
precision highp float;
#endif

uniform float uTime;
uniform vec2 uScreenSize;
uniform vec4 mouse;
uniform sampler2D tex0;

varying vec4 glFragCoord;

void main(void)
{
    vec2 p = glFragCoord.xy;
    vec2 m = -1.0 + 2.0 * mouse.xy / uScreenSize.xy;

    float a1 = atan(p.y-m.y,p.x-m.x);
    float r1 = sqrt(dot(p-m,p-m));
    float a2 = atan(p.y+m.y,p.x+m.x);
    float r2 = sqrt(dot(p+m,p+m));

    vec2 uv;
    uv.x = 0.2*uTime + (r1-r2)*0.25;
    uv.y = sin(2.0*(a1-a2));

    float w = r1*r2*0.8;
    vec3 col = texture2D(tex0,uv).xyz;

    gl_FragColor = vec4(col/(.1+w),1.0);
}
