#ifdef GL_ES
precision highp float;
#endif

uniform vec2 uScreenSize;
uniform float uTime;
uniform sampler2D tex0;
uniform sampler2D tex1;

varying vec4 glFragCoord;
uniform vec2 uMouse;

vec3 deform( in vec2 p )
{
	vec2 m = uMouse / uScreenSize;
    return texture2D(tex0, (p - m) * 0.8).xyz;
}

void main(void)
{
    vec2 p = glFragCoord.xy;
    vec2 s = p;

    vec3 total = vec3(0.0);
    vec2 d = (vec2(0.0,0.0)-p)/40.0;
    float w = 1.0;
    for( int i=0; i<10; i++ )
    {
        vec3 res = deform(s);
        res = smoothstep(0.1,1.0,res*res);
        total += w*res;
        w *= .99;
        s += d;
    }
    total /= 40.0;
    float r = 1.5/(1.0+dot(p,p));
    gl_FragColor = vec4( total*r,1.0);
}
