#ifdef GL_ES
precision highp float;
#endif

uniform vec2 uScreenSize;
uniform float uTime;
uniform sampler2D tex0;
uniform sampler2D tex1;

varying vec4 glFragCoord;

void main(void)
{
   vec2 p = glFragCoord.xy;
   vec2 uv;

   float a = atan(p.y,p.x) + uTime;
   float c = cos (a);
   float s = sin (a);

   float r = sin(uTime) * sqrt(dot(p,p));

   uv.x = r * c ;
   uv.y = r * s ;

   vec3 col1;
   col1 = texture2D(tex0, uv).xyz;
   // scroll
   vec3 col2 = texture2D(tex1, 0.5 * p + sin(0.1*uTime)).xyz;

    // blend layers
   vec3 col = col2 * col1;
   gl_FragColor = vec4(col, 1.0);
}

