#ifdef GL_ES
precision highp float;
#endif

uniform float uTime;
uniform vec2 uScreenSize;
uniform sampler2D tex0;

varying vec4 glFragCoord;

void main(void)
{
    vec2 uv;

    vec2 p = glFragCoord.xy;
    float a = atan(p.y,p.x);
    float r = sqrt(dot(p,p));
    float s = r * (1.0+0.8*cos(uTime*1.0));

    uv.x =          .02*p.y+.03*cos(-uTime+a*3.0)/s;
    uv.y = .1*uTime +.02*p.x+.03*sin(-uTime+a*3.0)/s;

    float w = .9 + pow(max(1.5-r,0.0),4.0);

    w*=0.6+0.4*cos(uTime+3.0*a);

    vec3 col =  texture2D(tex0,uv).xyz;

    gl_FragColor = vec4(col*w,1.0);
}
